
// nmake /f testDynaRoutine.mak
// #include "oorexxapi.h"
#include <oorexxapi.h>
#include <stdio.h>                     /* needed for printf()        */
#include <string.h>                    /* needed for strlen()        */

int main()
{

/*
    CONSTRXSTRING arg;                  // argument string for REXX  //
    RXSTRING rexxretval;                // return value from REXX    //

    char     *str = "These words will be swapped"; // text to swap   //

    RexxReturnCode   rc;                        // return code from REXX     //
    short    rexxrc = 0;                // return code from function //

    printf("\nThis program will call the REXX interpreter ");
    printf("to reverse the order of the\n");
    printf("\twords in a string.  ");
    printf("The interpreter is invoked with an initial\n");
    printf("\tenvironment name of 'FNC' ");
    printf("and a file name of 'BACKWARD.FNC'\n\n");

    // By setting the strlength of the output RXSTRING to zero, we   //
    // force the interpreter to allocate memory and return it to us. //
    // We could provide a buffer for the interpreter to use instead. //
    rexxretval.strlength = 0L;          // initialize return to empty//

    MAKERXSTRING(arg, str, strlen(str));// create input argument     //

    // Here we call the interpreter.                                 //
    rc=RexxStart(1,                         // number of arguments   //
                 &arg,                      // array of arguments    //
                 "BACKWARD.FNC",            // name of REXX file     //
                 0,                         // No INSTORE used       //
                 "FNC",                     // Command env. name     //
                 RXSUBROUTINE,              // Code for how invoked  //
                 0,                         // No EXITs on this call //
                 &rexxrc,                   // Rexx program output   //
                 &rexxretval );             // Rexx program output   //

    printf("Interpreter Return Code: %d\n", rc);
    printf("Function Return Code:    %d\n", (int) rexxrc);
    printf("Original String:         '%s'\n", arg.strptr);
    printf("Backwards String:        '%s'\n", rexxretval.strptr);

    RexxFreeMemory(rexxretval.strptr);      // Release storage       //
                                            // given to us by REXX.  //
    system("PAUSE");
//    return 0;

*/
// -----------------------------------------------------------------------


    fprintf(stderr, "Now creating a RexxInterpreter instance...\n");

    RexxInstance      *instance=NULL;

    RexxThreadContext *rtc;


    if (! (RexxCreateInterpreter(&instance, &rtc, NULL)))
    {
        fprintf(stderr, "RexxInterpreter could not get created, aborting!\n");
        exit ((int) -1);
    }


    char *c_routineName="TestRecursionAbend";

//     char *c_programData="say 'hallo'; return .nil";

    char *c_programData=
                "signal on any name error\n" \
                "say 'REXX START'\n" \
                "i=0\n" \
                "crash: i=i+1\n" \
                "       if i//100=0 then say i 'calls so far ...' \n" \
                "       call crash\n" \
                "       EXIT\n" \
                "error:\n" \
                "       say 'REXX ERROR after' i 'calls...'\n" \
                "EXIT -1\n";



    size_t len=strlen(c_programData);          // get length


    RexxRoutineObject rro=rtc->NewRoutine(c_routineName, c_programData, len);
    if (rro==NULL)          // something went wrong, condition will be set
    {
        fprintf(stderr, "Could not create new routine, aborting!\n");
        exit ((int) -2);
    }

    RexxArrayObject ra=NULL;
    RexxObjectPtr result_obj=rtc->CallRoutine(rro, ra);   // call the program

    return 0;
}
